#include <Process.au3>
#include <FileConstants.au3>
;#include <WinAPIFiles.au3>

Local $iniSection
Local $chDigits
Local $sMsg
Const $iniFile = "4742HDC.INI" 		;ini file containing different sections for each set top box
									;each section includes the individual commands for each channel digit (0-9)
									;all of my boxes are 4742HDC, so I used that as the name
;
;Sample of INI file contents below; IP2IR commands for set top box obtained from https://irdb.globalcache.com/Home/Database
;1:1 represents the 1st IR port, 1:2 would be for the 2nd, 1:3 would be for the 3rd
;
;[4742HDC1]
;DIGIT0=sendir,1:1,1,58000,1,1,194,194,48,145,48,145,48,48,48,145,48,145,48,145,48,48,48,48,48,145,48,145,48,48,48,48,48,48,48,145,48,48,48,48,48,48,48,145,48,145,48,48,48,48,48,145,48,2209
;DIGIT1=sendir,1:1,1,58000,1,1,194,194,48,145,48,145,48,48,48,145,48,145,48,48,48,48,48,48,48,48,48,145,48,48,48,48,48,48,48,145,48,48,48,48,48,145,48,145,48,145,48,145,48,48,48,145,48,2209
;...etc...
;

Const $cmdFile = "cmdfile.txt"		;IP2IR command file created by the script
Const $sIPAddress = "xxx.xxx.xxx.xxx"	;IP2IR IP address
Const $tcpPort = 4998				;IP2IR tcp port

if $CmdLine[0] > 1 then
	$iniSection = "4742HDC" & $CmdLine[1]		;first parameter is the SageTV-passed device number configured for exemultituner
												;the INI file sections are named accordingly ([4742HDC1] for the 1st device)
												;
	$chDigits = StringSplit ( $CmdLine[2], "")	;second parameter is the channel, which is split up to obtain commands for each digit
	$sMsg = ""
	;look for the IP2IR command in the INI file for each channel digit
	;build a string containing the full channel command set for the IP2IR
	For $i = 1 To $chDigits[0]
		$sMsg = $sMsg & IniRead($iniFile,$iniSection,"DIGIT" & $chDigits[$i],"")
		$sMsg = $sMsg & @CRLF
	Next
EndIf

Local $hFileOpen = FileOpen($cmdFile, $FO_OVERWRITE)
FileWrite($hFileOpen, $sMsg)
FileClose($hFileOpen)

;Local $iRc = _RunDos("type " & $cmdFile & "|nc64.exe -c -i 1 -w 1 " & $sIPAddress & " " & $tcpPort) ;might need 64 bit version of nc.exe
Local $iRc = _RunDos("type " & $cmdFile & "|nc.exe -c -i 1 -w 1 " & $sIPAddress & " " & $tcpPort)
